"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var RADIUS = 2000.0;
var MAX_RESULTS = 20;
var INCLUDED_TYPES = ["park"];
var map;
var pos = { lat: 30, lng: -110 };
function initMap() {
    return __awaiter(this, void 0, void 0, function () {
        var Map;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, google.maps.importLibrary("maps")];
                case 1:
                    Map = (_a.sent()).Map;
                    map = new Map(document.getElementById("map"), {
                        center: pos,
                        zoom: 8,
                        mapId: "DEMO_MAP",
                    });
                    return [2 /*return*/];
            }
        });
    });
}
function find_places(position) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, AdvancedMarkerElement, PinElement, InfoWindow, response, locations, infoWindow, labels, markers;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, google.maps.importLibrary("marker")];
                case 1:
                    _a = _b.sent(), AdvancedMarkerElement = _a.AdvancedMarkerElement, PinElement = _a.PinElement;
                    return [4 /*yield*/, google.maps.importLibrary("maps")];
                case 2:
                    InfoWindow = (_b.sent()).InfoWindow;
                    return [4 /*yield*/, fetch("https://places.googleapis.com/v1/places:searchNearby", {
                            method: "POST",
                            headers: new Headers({
                                "Content-Type": "application/json",
                                "X-Goog-Api-Key": "AIzaSyCneCqjzobnZ-ksYh85eosk1whovucTjQE",
                                "X-Goog-FieldMask": "places.location,places.displayName",
                            }),
                            body: JSON.stringify({
                                includedTypes: INCLUDED_TYPES,
                                maxResultCount: MAX_RESULTS.toString(),
                                locationRestriction: {
                                    circle: {
                                        center: {
                                            latitude: position.lat,
                                            longitude: position.lng,
                                        },
                                        radius: RADIUS.toString(),
                                    },
                                },
                            })
                        })];
                case 3:
                    response = _b.sent();
                    return [4 /*yield*/, response.json()];
                case 4:
                    locations = _b.sent();
                    infoWindow = new google.maps.InfoWindow({
                        content: "",
                        disableAutoPan: true,
                    });
                    console.log(locations);
                    labels = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
                    markers = locations["places"].map(function (element, i) {
                        var place = element["location"];
                        var latitude = place["latitude"];
                        var longitude = place["longitude"];
                        var label = labels[i % labels.length];
                        var pinGlyph = new google.maps.marker.PinElement({
                            glyph: label,
                            glyphColor: "white"
                        });
                        var marker = new google.maps.marker.AdvancedMarkerElement({
                            position: {
                                lat: latitude,
                                lng: longitude,
                            },
                            content: pinGlyph.element,
                        });
                        marker.addListener("click", function () {
                            infoWindow.setContent(position.lat + ", " + position.lng);
                            infoWindow.open(map, marker);
                        });
                        return marker;
                    });
                    // @ts-ignore
                    new markerClusterer.MarkerClusterer({ markers: markers, map: map });
                    return [2 /*return*/];
            }
        });
    });
}
function handle_geolocation() {
    return __awaiter(this, void 0, void 0, function () {
        var AdvancedMarkerElement;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, google.maps.importLibrary("marker")];
                case 1:
                    AdvancedMarkerElement = (_a.sent()).AdvancedMarkerElement;
                    navigator.geolocation.getCurrentPosition(function (position) {
                        pos = {
                            lat: position.coords.latitude,
                            lng: position.coords.longitude,
                        };
                        map.setCenter(pos);
                        map.setZoom(15);
                        find_places(pos);
                        new AdvancedMarkerElement({
                            map: map,
                            position: pos,
                            title: "You",
                        });
                    });
                    return [2 /*return*/];
            }
        });
    });
}
initMap().then(function () {
    if (navigator.geolocation) {
        handle_geolocation();
    }
});
